#include "random.h"
/*+----------------------------------------------------------------------------------------------+*/
static int RANDOM_iSeed = 1;
/*+----------------------------------------------------------------------------------------------+*/
/*!
\brief
   Init randomizer

\param Seed
   Value to init the randomizer with
This function seeds the random number generator
*/
void RANDOM_Init(int Seed)
{
   RANDOM_iSeed=Seed;
}
/*+----------------------------------------------------------------------------------------------+*/
/*!
\brief Get a random number

\return
   Returns a random number.

\note
   This functions is a lot faster than the original rand() function, at least on GBA :)
*/
int RANDOM_Get(void)
{
   RANDOM_iSeed >>= 1;

   if(RANDOM_iSeed&1)
   {
      RANDOM_iSeed ^= 0xb400;
   }

   return(RANDOM_iSeed);
}
/*+----------------------------------------------------------------------------------------------+*/


/* END OF FILE */

