#include "lib/mygcn.h"

// duke released the assembler code of this on his page.
// so, here is the c/c++ version
#define REG_HOTRESET             (0xCC003024)
#define REG_HOTRESET_PTR         ((volatile u32*)REG_HOTRESET)
#define M_HOTRESET               *REG_HOTRESET_PTR = 0x00000000;

// pad structure
PAD g_Pad;

// framebuffer pointer
u32 *g_pFrameBuffer=MEM_RAM_LOGICAL_PTR;


int main()
{
   // Initialize video interface
   VIDEO_Init(VIDEO_640X480_NTSC_YUV16);

   // Set framebuffer1 address
   VIDEO_SetFrameBuffer(VIDEO_FRAMEBUFFER_BOTH, (u32)g_pFrameBuffer);

   // Init the debug text system
   DEBUG_InitText(g_pFrameBuffer, COLOR_WHITE);


   // Inifinite loop
   while(TRUE)
   {
      // Clear the framebuffer
      RENDER_ClearFrameBuffer(g_pFrameBuffer, COLOR_FUCHSIA);

      // Read pad state
      PAD_ReadState(&g_Pad, PAD_CHANNEL_0);

      // start + A pressed?
      if(g_Pad.Digital.Start && g_Pad.Digital.A)
      {
         // reset
         M_HOTRESET;
      }

      // start + B pressed?
      if(g_Pad.Digital.Start && g_Pad.Digital.B)
      {
         // calling this function with NULL as parameter should raise an assertion
         RENDER_ClearFrameBuffer(NULL, COLOR_MAROON);
      }

      // print some text
      DEBUG_Print(30, 30, "Hello World :-)");
      DEBUG_Print(30, 80, "Press START + A to reset.");

      DEBUG_Print(30, 180, "Or press START + B to \nraise an assertion.");

      // Wait for vertical retrace
      VIDEO_WaitVSync();
   }

   return TRUE;
}
